
var visibilityControls = $H();
var visibilityValues = $H();
var visibilityTypes = $H();
var visibilityBackup = $H();
var visibilityMenus = $H();
var visibilityCount = 0;


Event.observe(document, 'click', function(e) {
	hideAllVisibilityMenus();
}); 

function isVisibilityControlMode()
{
	return hasClass(document.body, 'visibilityControlMode');
}

function setVisibilityValue(name, value)
{
	removeClass(visibilityControls.get(name), visibilityValues.get(name) + 'Visibility');
	visibilityValues.set(name, value);
	addClass(visibilityControls.get(name), visibilityValues.get(name) + 'Visibility');
	var options = visibilityMenus.get(name).getElementsByTagName('li');
	for (var i = 0; i < options.length; i++) {
		if (hasClass(options[i], value + 'VisibilityOption')) {
			document.getElementById('vhead-' + name).innerHTML = options[i].innerHTML;
			break;
		}
	}
}

function addVisibilityControl(name, visibility, controlType)
{
	var control = document.getElementById('vid-' + name);
	var menu = document.getElementById('vmenu-' + name);
	if (!menu)
		menu = control;

	if (!hasClass(control, 'customizableControl')) {
		var current = control.parentNode;
		while (current != document) {
			if (hasClass(current, 'toolsArea'))
				break;
			current = current.parentNode;
		}
		if (current == document)
			return;
	}

	visibilityControls.set(name, control);
	visibilityMenus.set(name, menu);
	visibilityValues.set(name, visibility);
	visibilityTypes.set(name, controlType);
	visibilityCount++;

	menu.onclick = function (e) {
		if (hasClass(this, 'controlVisibilityActive'))
			return false;
		hideAllVisibilityMenus();
	        if (!e) var e = window.event;
        	e.cancelBubble = true;
	        if (e.stopPropagation) e.stopPropagation();
		if (isVisibilityControlMode())
			addClass(this, 'controlVisibilityActive');
		return false;
	};

	var options = menu.getElementsByTagName('li');
	for (var i = 0; i < options.length; i++) {
	        options[i].onclick = function (e) {
			if (!name)
				var name = this.parentNode.id.replace(/^vlist-/, '');
			if (!e) var e = window.event;
			e.cancelBubble = true;
			if (e.stopPropagation) e.stopPropagation();
			removeClass(this, 'activeVisibilityOption');
			removeClass(visibilityMenus.get(name), 'controlVisibilityActive');

			for (var value in {'show': '', 'adminOnly': '', 'hide': '', 'default': ''}) {
				if (hasClass(this, value + 'VisibilityOption')) {
					setVisibilityValue(name, value);
					break;
				}
			}
			return false;
        	};
	}
}

function collectVisibilityValues(form)
{
	visibilityValues.each(function (pair) {
		var page;
		var control;
		var item;
		var parts = pair.key.split(':', 2);
		if (parts.length == 2) {
			page = parts[0];
			control = parts[1];
		} else {
			page = visibilityPage;
			control = pair.key;
		}
		item = form.ownerDocument.createElement("input");
		item.setAttribute("type", "hidden");
		item.setAttribute("name", "customizations[" + page + "][" + control + "][visibility]");
		item.setAttribute("value", visibilityValues.get(pair.key));
		form.insertBefore(item, null);
		item = form.ownerDocument.createElement("input");
		item.setAttribute("type", "hidden");
		item.setAttribute("name", "customizations[" + page + "][" + control + "][controlType]");
		item.setAttribute("value", visibilityTypes.get(pair.key));
		form.insertBefore(item, null);
	});
}

function hideAllVisibilityMenus() {
	visibilityMenus.each(function(pair) {
			removeClass(pair.value, 'controlVisibilityActive');
	});
}
