-- Bug 113259, unique index on CHARACTER SET utf8 COLLATE utf8_general_ci

ALTER TABLE `clients` DROP INDEX `pname`;
ALTER TABLE `clients` ADD INDEX (`pname`);

ALTER TABLE `domains` DROP INDEX `displayName`;
ALTER TABLE `domains` ADD INDEX (`displayName`);

ALTER TABLE `subdomains` DROP INDEX `dom_id_2`;
ALTER TABLE `subdomains` ADD INDEX `dom_id_displayName` (`dom_id`, `displayName`);

ALTER TABLE `mass_mail` DROP INDEX `name`;
ALTER TABLE `mass_mail` ADD INDEX (`name`);

ALTER TABLE `mail_resp` DROP INDEX `mn_id`;
ALTER TABLE `mail_resp` ADD INDEX `mn_id_resp_name` (`mn_id`, `resp_name`);

ALTER TABLE `badmailfrom` DROP INDEX `domain`;
ALTER TABLE `badmailfrom` ADD INDEX (`domain`);

ALTER TABLE `DatabaseServers` DROP INDEX `host`;
ALTER TABLE `DatabaseServers` ADD INDEX `host_port` (`host`, `port`);

ALTER TABLE `Skins` DROP INDEX `name`;
ALTER TABLE `Skins` ADD INDEX (`name`);

ALTER TABLE `spamfilter_preferences` DROP INDEX `spamfilter_id`;
ALTER TABLE `spamfilter_preferences` ADD INDEX `spamfilter_id` (`spamfilter_id`, `preference`, `value`);

ALTER TABLE `DashboardPreset` DROP INDEX `name_type`;
ALTER TABLE `DashboardPreset` ADD INDEX `name_type` (`name`, `type`);

-- SiteApp

ALTER TABLE SiteAppPackages ADD COLUMN package_type INT UNSIGNED NOT NULL DEFAULT 0;
ALTER TABLE SiteAppPackages ADD COLUMN params_id INT UNSIGNED;
ALTER TABLE SiteAppPackages ADD KEY params_id (params_id);

ALTER TABLE SiteAppResources ADD COLUMN res_param_1 VARCHAR(255) CHARACTER SET ascii COLLATE ascii_bin DEFAULT '';

ALTER TABLE DatabaseServers ADD COLUMN server_version VARCHAR(255) CHARACTER SET BINARY NOT NULL;

INSERT INTO actions (name, descr, enabled) VALUES('siteapp_upgrade', 'Upgrade site application', 'true');

-- SSO

ALTER TABLE clients ADD COLUMN uid VARCHAR(36) CHARACTER SET ascii COLLATE ascii_bin AFTER sapp_pool_id;
ALTER TABLE clients ADD COLUMN ownership ENUM('true', 'false') NOT NULL DEFAULT 'true' AFTER uid;

ALTER TABLE dom_level_usrs ADD COLUMN uid VARCHAR(36) CHARACTER SET ascii COLLATE ascii_bin AFTER perm_id;
ALTER TABLE dom_level_usrs ADD COLUMN ownership ENUM('true', 'false') NOT NULL DEFAULT 'true' AFTER uid;

INSERT INTO NewsArticles(class) VALUES ('WhatsNew8_2');

