-- SpamFilter tables create
CREATE TABLE IF NOT EXISTS spamfilter (
	id						INT UNSIGNED AUTO_INCREMENT PRIMARY KEY
,	username				VARCHAR(128) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL
								-- mailnames for spamfilter control ?:
								-- full mailname for mailuser (e.g. foo@bar.com),
								-- with * as local part for domain (e.g. *@bar.com),
								-- *@* for server.
,	preferences				ENUM('false','true') NOT NULL DEFAULT 'false'
								-- Are preferences active?
,	reject_spam				ENUM('false','true') NOT NULL DEFAULT 'false'
								-- Are spam messages not delivered?
,							UNIQUE (username)
) TYPE=InnoDB;

CREATE TABLE IF NOT EXISTS spamfilter_preferences (
	prefid					INT UNSIGNED AUTO_INCREMENT PRIMARY KEY
,	spamfilter_id			INT UNSIGNED NOT NULL
,	preference				VARCHAR(30) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT ''
,	value					VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT ''
,							INDEX spamfilter_id (spamfilter_id, preference, value)
) TYPE=InnoDB;

REPLACE INTO misc (param, val) VALUES('spamfilter_enabled', 'true');
REPLACE INTO misc (param, val) VALUES('spamfilter_use_mailuser_prefs', 'true');

-- Greylisting settings(in minutes)
CREATE TABLE IF NOT EXISTS `GL_settings` (
    `param` varchar(255) character set ascii COLLATE ascii_bin NOT NULL UNIQUE,
    `value` varchar(255) character set ascii COLLATE ascii_bin NOT NULL,
    PRIMARY KEY `param` (`param`)
) TYPE=InnoDB;

-- Default greylisting settings(in minutes)
REPLACE INTO GL_settings (param, value) VALUES ('greyInterval', '5');
REPLACE INTO GL_settings (param, value) VALUES ('expireInterval', '51840');
REPLACE INTO GL_settings (param, value) VALUES ('penaltyInterval', '2');
REPLACE INTO GL_settings (param, value) VALUES ('penaltyEnabled', 'false');
REPLACE INTO GL_settings (param, value) VALUES ('enabled', 'false');

-- upgrade DashboardPreset
REPLACE INTO DashboardPreset (uri, name, type) values ('/plesk/dashboard/', 'Default Administrator Home Page', 'admin');
SET @id = LAST_INSERT_ID();
REPLACE INTO misc (param, val) VALUES ('def_admin_preset_id', @id);
REPLACE INTO misc (param, val) VALUES ('admin_preset_id', @id);

REPLACE INTO DashboardPreset (uri, name, type) values ('/plesk/client@/dashboard/', 'Default Client Home Page', 'client');
SET @id = LAST_INSERT_ID();
REPLACE INTO misc (param, val) VALUES ('def_client_preset_id', @id);

REPLACE INTO DashboardPreset (uri, name, type) values ('/plesk/client@/domain@/dashboard/', 'Default Domain Owner Home Page', 'domain');
SET @id = LAST_INSERT_ID();
REPLACE INTO misc (param, val) VALUES ('def_domain_preset_id', @id);

REPLACE INTO DashboardPreset (uri, name, type) values ('/plesk/reseller@/dashboard/', 'Default Reseller Home Page', 'reseller');
SET @id = LAST_INSERT_ID();
REPLACE INTO misc (param, val) VALUES ('def_reseller_preset_id', @id);
