-- 920 rudimentary upgrade implementation
DROP TABLE IF EXISTS `GL_white_remote_domains`;

-- Greylisting server-wide black/white lists
CREATE TABLE IF NOT EXISTS `GL_remote_domains` (
    `domain` VARCHAR(255) character set ascii COLLATE ascii_bin NOT NULL UNIQUE
,   `type`   enum('black','white') NOT NULL DEFAULT 'black'
) TYPE=InnoDB;

-- Enhanced reporting
CREATE TABLE IF NOT EXISTS `PleskPagesStat` (
  `date` DATE NOT NULL,
  `url` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `hits` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY  (date, url)
) TYPE=InnoDB;

CREATE TABLE IF NOT EXISTS `MailMessagesStat` (
  `date` DATE NOT NULL,
  `sent` BIGINT(20) UNSIGNED NOT NULL default '0',
  PRIMARY KEY  (date)
) TYPE=InnoDB;

CREATE TABLE IF NOT EXISTS `SitePagesStat` (
  `date` DATE NOT NULL,
  `hits` BIGINT(20) UNSIGNED NOT NULL default '0',
  PRIMARY KEY  (date)
) TYPE=InnoDB;

-- Greylisting default server-wide white list
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*google.com', 'white');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*yahoo.com', 'white');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*parallels.com', 'white');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*mail.ru', 'white');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*yandex.ru', 'white');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*rambler.ru', 'white');

-- Greylisting default server-wide black list
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('dynamic|static|ppp|dyn-ip|dial-up', 'black');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('dsl|pool|broadband|hsd', 'black');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*[0-9][0-9].[0-9][0-9].[0-9][0-9]*', 'black');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*[0-9][0-9][0-9].[0-9][0-9][0-9].[0-9[0-9]][0-9]*', 'black');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*[0-9][0-9]-[0-9][0-9]-[0-9][0-9]*', 'black');
REPLACE INTO GL_remote_domains (domain, `type`) VALUES('*[0-9][0-9][0-9]-[0-9][0-9][0-9]-[0-9][0-9][0-9]*', 'black');

